import signal
import sys
import threading

from libraries.base.config import ConfigReader
#from libraries.reporting.messenger import RedisListener
from modules.controller.controller import AuraController
#from modules.communication.zmq.zmqadapter import ServerZMQAdapter
from modules.communication.redis.redisadapter import ServerRedisAdapter


class Aura():
    server = None
    config = None
    messenger = None
    controller = None

    def __init__(self):
        self.config = ConfigReader()
        self.config.loadConfig()

        server = object

        self.controller = AuraController(self.config, debug=False)
        #self.server = ServerZMQAdapter(self.controller, self.config, debug=True)
        #self.redislistener =

        self.messenger = ServerRedisAdapter()
        self.messenger.set_controller(self.controller)
        self.messenger.set_config(self.config)

        def receive_signal(signum, stack):
            print("received signal")
            server.reload()

        signal.signal(signal.SIGUSR1, receive_signal)

    def join_comm(self):
        # start listener thread
        self.messenger.start()

# # ## ## ## ## ## # #
# # ENTRY FUNCTION # #
# # ## ## ## ## ## # #
def main():
    aura = Aura()
    aura.join_comm()

# # ## ## ## ## ## ## # #
# # End ENTRY FUNCTION # #
# # ## ## ## ## ## ## # #

if __name__ == "__main__":
    main()