import time
import threading

from libraries.exceptions.auraexceptions import LQConnectionError


class LiquidSoapInitThread(threading.Thread):
    socket = None
    liquidsoapcommunicator = None

    def __init__(self, liquidsoapcommunicator, socket):
        threading.Thread.__init__(self)

        self.socket = socket
        self.liquidsoapcommunicator = liquidsoapcommunicator

    def run(self):
        try:
            # sleep needed, because the socket is created to slow by liquidsoap
            time.sleep(10)
            self.liquidsoapcommunicator.enable_transaction()
            self.liquidsoapcommunicator.open_conn(self.socket)
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "volume", "0", "0")
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "volume", "1", "0")
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "volume", "2", "0")
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "select", "0", "true")
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "select", "1", "true")
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "select", "2", "true")
            # a little hack => the cracklings stop after 5 seconds after restarting the liquidsoap server
            time.sleep(5)
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "select", "2", "true")

            self.liquidsoapcommunicator.close_conn(self.socket)
            self.liquidsoapcommunicator.disable_transaction()
        except LQConnectionError as e:
            print("Liquidsoap connection ERROR! Restart LQ Server!")
            print(e.message)
            print(e)
        except Exception as e:
            print(e)


